package com.care.bms.params;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class VoiceCallbackParams {

    @ApiModelProperty("错误码，0表示用户正常接听，1表示用户未接听， 2表示呼叫异常")
    private String result;

    @ApiModelProperty("用户接听时间")
    private String accept_time;

    @ApiModelProperty("呼入号码")
    private String call_from;

    @ApiModelProperty("标识本次发送 ID")
    private String callid;

    @ApiModelProperty("结束语音通知呼叫时间")
    private String end_calltime;

    @ApiModelProperty("计费时长，单位为分钟")
    private String fee;

    @ApiModelProperty("手机号码")
    private String mobile;

    @ApiModelProperty("国家（或地区）码")
    private String nationcode;

    @ApiModelProperty("开始发起语音通知呼叫时间")
    private String start_calltime;

}
